from requests import get
import os
import time


def GetPic():
    api = 'https://yuanxiapi.cn/api/Littlesister'
    headers = {
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.131 Safari/537.36'}
    url = get(api, headers=headers, timeout=2).request.url
    if url:
        return url


def Downfile(url, filename):
    headers = {
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.131 Safari/537.36'}
    file_data = get(url, headers=headers, timeout=2,
                    allow_redirects=True).content
    with open(filename, 'wb') as handler:
        handler.write(file_data)


def init():
    print("链接保存在程序同目录下的url.txt文件，图片保存在同目录下的img文件夹下。")
    down = input("是否同时开始下载图片[y/N](默认N,即仅采集图片链接)：")
    if down in ['Y','y','YES','Yes','yes','YeS','yES','yEs']:
        down=True
    else:
        down=False

    try:
        with open('url.txt', 'r') as f:
            urllist = f.read().splitlines()
    except:
        urllist = []
    print(urllist)

    dir = 'img/'
    if not os.path.exists(dir):
        os.makedirs(dir)

    i = 0
    ii = 0
    while i < 30 and ii < 3000:  # 连续30张图都重复或者本次采集到3000张图就停止
        url = GetPic()
        if url not in urllist:
            print(url)
            urllist.append(url)
            with open('url.txt', 'a') as f:
                f.write(url+'\n')
            ii = ii+1
            i = 0
        else:
            i = i+1
            print("重复次数"+str(i)+"(连续30次重复就停止)\n重复的Url: "+url)

        if down:
            filename = dir + os.path.basename(url)
            # 图片不存在或者为空的时候才下载
            if not os.path.isfile(filename) or os.path.getsize(filename) == 0:
                Downfile(url, filename)
                print("下载完成: "+filename)
                i = 0
        # time.sleep(1)


init()
